﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using BR.AN.PviServices;
using System.Windows.Forms;
using System.Runtime.InteropServices;

# 发布点：https://pvi.brhelp.cn/index.html?pvi-servicesdemo.html

namespace ConsoleApplication2
{
    class Program
    {
        static Service service;
        static Cpu cpu;
        static Variable variable;
        [STAThread]
        static void Main(string[] args)
        {

            Console.WriteLine("Connecting Service ...");
            service = new Service("Service");
            service.Error += new PviEventHandler(Error);
            service.Connected += new PviEventHandler(service_Connected);
            service.Connect();

            // Message loop
            Application.Run();
        }
        static void service_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Service Connected Error=" + e.ErrorCode.ToString());
            cpu = new Cpu(service, "Cpu");
            cpu.Connection.DeviceType = DeviceType.ANSLTcp;
            cpu.Connection.ANSLTcp.DestinationIpAddress = "127.0.0.1";
            cpu.Connected += new PviEventHandler(cpu_Connected);
            Console.WriteLine("Connecting Cpu ...");
            cpu.Connect();
        }

        static void cpu_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("---------------------------------------New Connneciton--------------");
            Console.WriteLine("Cpu Connected Error=" + e.ErrorCode.ToString());
            variable = new Variable(cpu, "gData");
            variable.Active = true;
            variable.RefreshTime = 1;
            variable.Polling = false;
            variable.ValueChanged += new VariableEventHandler(ValueChanged);
            variable.ValueRead += new PviEventHandler(ValueRead);
            variable.Connected += new PviEventHandler(variable_Connected);
            Console.WriteLine("Connecting Variable ...");
            variable.Connect();
        }

        static void variable_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Variable Connected Error=" + e.ErrorCode.ToString());
        }

        /// <summary>
        /// Exit application if an error occurs
        /// </summary>
        static void Error(object sender, PviEventArgs e)
        {
            Console.WriteLine(String.Format("Error:{0}", e.ErrorText));
            //Application.Exit();
        }

        /// <summary>
        /// Write variable value to the console
        /// </summary>
        static void ValueChanged(object sender, VariableEventArgs e)
        {
            Variable var = (Variable)sender;

            Int16 receive_date = Convert.ToInt16(var.Value["a"].ToString());
            if (receive_date != 0) {
                Console.WriteLine(DateTime.Now.ToString("yyyy - MM - dd hh: mm:ss.fff") + ":  " + "Value={0}", var.Value.ToString());

                Console.WriteLine("---------Goto Disconnected Step");

                //variable.Disconnected += new PviEventHandler(var_disconnected_fun);
                //variable.Disconnect();

                cpu.Disconnected += new PviEventHandler(cpu_disconnected_fun);
                cpu.Disconnect();
            }
        }

        static void ValueRead(object sender, PviEventArgs e)
        {
            Variable var = (Variable)sender;
 
            Console.WriteLine(" ReadValue:  " + "Value={0}", var.Value.ToString());
        }

        static void var_disconnected_fun(object sender, PviEventArgs e)
        {
            Console.WriteLine("--------- Disconnented");
            Console.WriteLine("---------  Try to get some data Before CPU Disconnected");
            variable.ReadValue();

            cpu.Disconnected += new PviEventHandler(cpu_disconnected_fun);
            cpu.Disconnect();
        }

        static void cpu_disconnected_fun(object sender, PviEventArgs e)
        {
            Console.WriteLine("---------  CPU Disconnented");

            Thread.Sleep(1000); //延时1s
            Console.WriteLine("---------  Try to get some data When CPU Disconnected");
            variable.ReadValue();

            Thread.Sleep(7000); //延时7s
            Console.WriteLine("---------  Start to reconnect");

            cpu = new Cpu(service, "Cpu");
            cpu.Connection.DeviceType = DeviceType.ANSLTcp;
            cpu.Connection.ANSLTcp.DestinationIpAddress = "127.0.0.1";
            cpu.Connected += new PviEventHandler(cpu_Connected);
            Console.WriteLine("Connecting Cpu ...");
            cpu.Connect();
        }
    }
}
